import React, { Component } from 'react';
import {
    View,
    Image,
    TouchableOpacity,
    Text
} from 'react-native';

import storeLocatorStyle from './storeLocatorStyle';



export default class StoreLocatorListItem extends Component {
    constructor(props) {
        super(props);
        this.state = {

            isRenderCallAlert: false

        };
    }

    componentWillMount() {

    }

    isValidString(data) {
        if (data !== '' && data !== undefined && data !== null) {
            return true;
        }
        return false;
    }

    render() {

        let myStore = (this.props.setAsMyStore == this.props.storeData.storeId)
        // if (!myStore) {//ODNA-144671
        return (
            <View accessibilityLabel={"storeLocatorListItem_view_container" + this.props.storeData.storeId}
                testID={"storeLocatorListItem_view_container" + this.props.storeData.storeId} >
                {this.renderStoresView(myStore)}
            </View>
        );

    }

    skuAvailabiltyLabel(skuArray) {
        var availableQty = 0;
        var stockAvailablety = ''
        for (let i = 0; i < skuArray.length; i++) {
            if (skuArray[i].skuAvailability.available) {
                availableQty++;
            }

        }
        stockAvailablety = availableQty + " of  " + skuArray.length + " In Stock"
        this.isOutOfStockSku = (availableQty != skuArray.length)
        return stockAvailablety;
    }

    async storeCellSelected(skuArray) {
        if (this.props.isShowStoreDetail) {
            //Actions.storelocatordetails({ storeData: this.props.storeData });
            this.props.navigation.push('StoreLocatorDetails', { storeData: this.props.storeData })
        } else {
            { this.props.showSkuList(skuArray) }
        }
    }

    renderStoresView(myStore) {
        let imageStore = (this.isValidString(this.props.storeData.storeCustomContent)) ? true : false;
        let rowID = parseInt(this.props.rowID)
        let isOfficeMaxStore = false;
        if (this.isValidString(this.props.storeData.brandName)) {
            isOfficeMaxStore = this.props.storeData.brandName.includes('max');
        } else if (this.isValidString(this.props.storeData.brand)) {
            isOfficeMaxStore = this.props.storeData.brand.includes('max')
        }


        var stockAvailablety = ''
        if (this.props.availableQty != undefined) {
            if (this.props.availableQty == 0) {
                stockAvailablety = "Out of Stock"
            } else if (this.props.availableQty < 4) {
                stockAvailablety = this.props.availableQty + " In Stock"
            } else {
                stockAvailablety = " In Stock"
            }
        }

        var stockAvailablety = this.skuAvailabiltyLabel(this.props.skuArray.skuDescriptionAndAvailabiltyInfos);

        return (
            <View accessibilityLabel={"storeLocatorListItem_button_store" + this.props.storeData.storeId}
                testID={"storeLocatorListItem_button_store" + this.props.storeData.storeId} accessible={false} style={{ flex: 1, marginTop: 20, marginBottom: 20 }}>
                <View accessibilityLabel={"storeLocatorListItem_view_store" + this.props.storeData.storeId}
                    testID={"storeLocatorListItem_view_store" + this.props.storeData.storeId} style={{ flex: 1, backgroundColor: 'white' }}>
                    <View accessibilityLabel={"storeLocatorListItem_outerView_store" + this.props.storeData.storeId}
                        testID={"storeLocatorListItem_outerView_store" + this.props.storeData.storeId} style={{ flexDirection: 'row' }}>
                        {this.renderImage(imageStore)}
                        <View accessibilityLabel={"storeLocatorListItem_innerView_store" + this.props.storeData.storeId}
                            testID={"storeLocatorListItem_innerView_store" + this.props.storeData.storeId} style={{ flex: 1, flexDirection: 'column', marginLeft: 10, left: 10 }}>
                            <View style={{ flexDirection: 'row', marginTop: 3 }}>
                                <Text accessibilityLabel={"storeLocatorListItem_text_storeSequence" + this.props.storeData.storeId}
                                    testID={"storeLocatorListItem_text_storeSequence" + this.props.storeData.storeId} style={{ color: "#273039", fontWeight: "bold", fontSize: 14, }}>{this.renderSequence(rowID, myStore)}</Text>
                                <Text accessibilityLabel={"storeLocatorListItem_text_city" + this.props.storeData.storeId}
                                    testID={"storeLocatorListItem_text_city" + this.props.storeData.storeId} style={{ color: "#273039", fontWeight: "bold", fontSize: 14, }}>{this.props.storeData.city + ', '}</Text>
                                <Text accessibilityLabel={"storeLocatorListItem_text_storeId" + this.props.storeData.storeId}
                                    testID={"storeLocatorListItem_text_storeId" + this.props.storeData.storeId} style={{ color: "#273039", fontWeight: "bold", fontSize: 14, }}>{'Store' + ' #' + this.props.storeData.storeId}</Text>
                            </View>
                            <Text accessibilityLabel={"storeLocatorListItem_text_storeAddress" + this.props.storeData.storeId}
                                testID={"storeLocatorListItem_text_storeAddress" + this.props.storeData.storeId} style={{ color: '#273039', fontSize: 12, }}>{this.props.storeData.address}</Text>
                            <View accessibilityLabel={"storeLocatorListItem_view_storeCityStateZip" + this.props.storeData.storeId}
                                testID={"storeLocatorListItem_view_storeCityStateZip" + this.props.storeData.storeId} style={{ flex: 1, flexDirection: 'row', }}>
                                <View style={{ flex: 1, alignItems: 'flex-start', flexDirection: 'row', }}>
                                    <Text accessibilityLabel={"storeLocatorListItem_text_storeCity" + this.props.storeData.storeId}
                                        testID={"storeLocatorListItem_text_storeCity" + this.props.storeData.storeId} style={{ color: '#273039', fontSize: 12 }}>{this.props.storeData.city + ', '}</Text>
                                    <Text accessibilityLabel={"storeLocatorListItem_text_storeState" + this.props.storeData.storeId}
                                        testID={"storeLocatorListItem_text_storeState" + this.props.storeData.storeId} style={{ color: '#273039', fontSize: 12 }}>{this.props.storeData.state + ', '}</Text>
                                    <Text accessibilityLabel={"storeLocatorListItem_text_storeZip" + this.props.storeData.storeId}
                                        testID={"storeLocatorListItem_text_storeZip" + this.props.storeData.storeId} style={{ color: '#273039', fontSize: 12 }}>{this.props.storeData.zip + ' '}</Text>
                                </View>
                            </View>
                            <Text accessibilityLabel={"storeLocatorListItem_text_storeDistance" + this.props.storeData.storeId}
                                testID={"storeLocatorListItem_text_storeDistance" + this.props.storeData.storeId} style={{ color: '#273039', fontWeight: "bold", fontSize: 12 }}>{this.props.storeData.distance + '  miles'}</Text>
                        </View>
                    </View>
                    <View accessibilityLabel={"storeLocatorListItem_view_storeFooter" + this.props.storeData.storeId}
                        testID={"storeLocatorListItem_view_storeFooter" + this.props.storeData.storeId} style={{ marginLeft: 20, flexDirection: 'row', marginRight: 20, marginTop: 3 }}>
                        <Text accessibilityLabel={"storeLocatorListItem_text_storeHours" + this.props.storeData.storeId}
                            testID={"storeLocatorListItem_text_storeHours" + this.props.storeData.storeId} style={{ color: '#273039', fontSize: 12, }}>{this.storeHoursLabel()}</Text>
                        <Text style={{ color: '#d1d2d4', fontSize: 12, }}> | </Text>
                        {/* <TouchableOpacity accessibilityLabel={"storeLocatorListItem_button_storePhoneNo" + this.props.storeData.storeId}
							testID={"storeLocatorListItem_button_storePhoneNo" + this.props.storeData.storeId} accessible={false} style={{ flexDirection: 'row', alignItems: 'center' }} onPress={() => { this.renderCallAlert(this.props.storeData.phoneWithHyphens) }}> */}


                        <TouchableOpacity accessibilityLabel={"storeLocatorItem_button_storePhoneNo" + this.props.storeData.storeId}
                            testID={"storeLocatorItem_button_storePhoneNo" + this.props.storeData.storeId} accessible={false} style={{ flexDirection: 'row', alignItems: 'center', marginLeft: 10, marginRight: 10 }} onPress={() => { this.setState({ isRenderCallAlert: true }) }}>
                            <Text accessibilityLabel={"storeLocatorListItem_text_storePhoneNo" + this.props.storeData.storeId}
                                testID={"storeLocatorListItem_text_storePhoneNo" + this.props.storeData.storeId} style={{ marginLeft: 3, color: '#1e5a99', fontSize: 12, }}>{this.props.storeData.phoneWithHyphens}</Text>
                        </TouchableOpacity>
                    </View>
                    <View style={{ marginLeft: 20, marginRight: 20, marginTop: 3 }}>
                        <TouchableOpacity accessibilityLabel={"storeLocatorListItem_button_viewWeeklyAds" + this.props.storeData.storeId}
                            testID={"storeLocatorListItem_button_viewWeeklyAds" + this.props.storeData.storeId} accessible={false} style={{ marginRight: 20 }} onPress={() => { this.props.handleClickStoreCell(this.props.skuArray, this.props.availableQty); }}>


                            <Text accessibilityLabel={"storeLocatorListItem_text_viewWeeklyAds" + this.props.storeData.storeId}
                                testID={"storeLocatorListItem_text_viewWeeklyAds" + this.props.storeData.storeId} style={{ color: '#1e5a99', fontSize: 12, }}>{'View Items Available'}</Text>
                        </TouchableOpacity>
                    </View>
                    <View accessibilityLabel={"storeLocatorListItem_view_stockAvailabilityAndSetStore" + this.props.storeData.storeId}
                        testID={"storeLocatorListItem_view_stockAvailabilityAndSetStore" + this.props.storeData.storeId} style={{ flexDirection: 'row', justifyContent: 'space-between', }} >
                        <Text accessibilityLabel={"storeLocatorListItem_text_stockAvailability" + this.props.storeData.storeId}
                            testID={"storeLocatorListItem_text_stockAvailability" + this.props.storeData.storeId} style={{ flex: 1, marginTop: 20, alignItems: 'flex-start', textAlign: 'left', marginLeft: 20, color: this.stockLabelColor(stockAvailablety), fontSize: 14 }}>{stockAvailablety}</Text>
                        {this.renderSetStoreButton(myStore)}</View>

                </View>

            </View>
        );
    }

    renderSequence(rowID, myStore) {
        if (!myStore) {
            return (rowID + 1).toString() + '.' + " "
        }
        else {
            return "";
        }
    }

    renderImage(imageStore) {
        if (imageStore && this.isValidString(this.props.storeData.storeCustomContent.defaultImage)) {
            let imageLink = this.props.storeData.storeCustomContent.defaultImage
            return (<View accessibilityLabel={"storeLocatorListItem_imageView_store" + this.props.storeData.storeId}
                testID={"storeLocatorListItem_imageView_store" + this.props.storeData.storeId} style={{ marginLeft: 20, marginTop: 10, backgroundColor: 'transparent', }}>
                <Image accessibilityLabel={"storeLocatorListItem_image_store" + this.props.storeData.storeId}
                    testID={"storeLocatorListItem_image_store" + this.props.storeData.storeId} source={{ uri: 'https://officedepot.scene7.com/is/image/officedepot/' + imageLink + '&fmt=png-alpha' }}
                    style={{ width: 60, height: 60, borderRadius: 30, borderWidth: 1 }} resizeMode='cover' />
            </View>)
        }
        else {
            return (
                <View></View>
            )
        }
    }


    stockLabelColor(skuQty) {
        if (skuQty == 'Out of Stock') {
            return 'rgba(204.0,0,0,1.0)'
        } else {
            return 'rgba(117.0,186,0,1.0)'
        }
    }

    handleClick(phoneNumber) {
        const args = {
            number: phoneNumber,
            prompt: true
        }
        call(args).catch("console.error")
    }



    renderSetStoreButton(flag) {
        if (!flag) {
            return (
                <TouchableOpacity accessibilityLabel={"storeLocatorListItem_button_setAsMyStore" + this.props.storeData.storeId}
                    testID={"storeLocatorListItem_button_setAsMyStore" + this.props.storeData.storeId} accessible={false} onPress={() => { this.props.setMyStore(this.props.storeData.storeId, this.isOutOfStockSku) }}>
                    <View accessibilityLabel={"storeLocatorListItem_textView_setAsMyStore" + this.props.storeData.storeId}
                        testID={"storeLocatorListItem_textView_setAsMyStore" + this.props.storeData.storeId} style={storeLocatorStyle.setStoreLocatorView}>
                        <Text accessibilityLabel={"storeLocatorListItem_text_setAsMyStore" + this.props.storeData.storeId}
                            testID={"storeLocatorListItem_text_setAsMyStore" + this.props.storeData.storeId} style={storeLocatorStyle.setStoreTextView}>{'Set as My Store'}</Text>
                    </View>
                </TouchableOpacity>
            )
        } else {
            return (
                <View accessibilityLabel={"storeLocatorItem_textView_stockLabel"} testID={"storeLocatorItem_textView_stockLabel"} style={{ flex: 1, marginTop: 5 }}>
                    <TouchableOpacity nPress={() => { }} style={{ alignSelf: 'flex-end', backgroundColor: 'red', height: 32, width: 120, borderRadius: 1, marginRight: 20 }}>
                        <Text style={{ textAlign: 'center', color: 'white', fontSize: 12, marginTop: 6, marginBottom: 5, textAlign: 'center' }}>{"My Store"}</Text>
                    </TouchableOpacity>
                </View>
            )
        }
    }

	/*Method Name   : storeHoursLabel
	  Description     : function to get store open hours
	  Author          : Avnish Chuchra*/
    storeHoursLabel() {
        if (this.props.storeData) {
            if (this.isValidString(this.props.storeData.storeAvailMessage)) {
                return this.props.storeData.storeAvailMessage;
            } else {
                let day = new Date().getDay();
                let dayHours = this.getDayHours(day);
                let openCloseTime = this.openCloseTime(dayHours);
                return openCloseTime;
            }
        } else {
            return ''
        }
    }

	/*Method Name   : getDayHours
	Description     : function return store times for day
	Author          : Avnish Chuchra*/
    getDayHours(day) {
        switch (day) {
            case 0:
                return this.props.storeData.hoursSun;
            case 1:
                return this.props.storeData.hoursMon;
            case 2:
                return this.props.storeData.hoursTue;
            case 3:
                return this.props.storeData.hoursWed;
            case 4:
                return this.props.storeData.hoursThu;
            case 5:
                return this.props.storeData.hoursFri;
            case 6:
                return this.props.storeData.hoursSat;
            default:
                return '';
        }
    }

	/*Method Name   : openCloseTime
	Description     : function to get store open or close time to display on store cell
	Author          : Avnish Chuchra*/
    openCloseTime(time) {
        if (this.isValidString(time)) {

            var res = (time.includes('-')) ? time.split("-") : [];
            if (res.length > 1) {
                var openTime = res[0];
                let closeTime = res[1];
                let currentTime = new Date().getHours()
                let currMinutes = new Date().getMinutes()
                let openHour = (openTime.includes(":")) ? openTime.split(":")[0] : '';
                let openMinutes = (openTime.includes(":")) ? openTime.split(":")[1] : '';
                let closeMinutes = (closeTime.includes(":")) ? closeTime.split(":")[1] : '';
                var closeHour = (closeTime.includes(":")) ? closeTime.split(":")[0] : '';
                if (parseInt(openHour) < 10) {
                    openTime = openTime.replace("0", "");
                }

                if (parseInt(closeHour) < 10) {

                    closeTime = closeTime.replace("0", "");
                }
                let closeString = 'Closed until';
                let openString = 'Open until'
                if (closeTime.includes('PM')) {
                    closeHour = (parseInt(closeHour) + 12).toString()
                }
                // current time (hours) < open time (hours) :: CLOSED {1}
                if (parseInt(currentTime) < parseInt(openHour)) {
                    return closeString + ' ' + openTime;
                }
                // current time (hours) > close time (hours) :: CLOSED {2}
                if (parseInt(currentTime) > parseInt(closeHour)) {
                    let day = new Date().getDay();
                    let dayHours = this.getDayHours(day + 1);
                    var res = (dayHours.includes("-")) ? dayHours.split("-") : [];
                    return (res.length > 0) ? closeString + ' ' + res[0] : closeString;
                }
                // current time (hours) > open time (hours) && current time (hours) < closed time (hours) :: OPEN {3}
                if ((parseInt(currentTime) > parseInt(openHour)) && (parseInt(currentTime) < parseInt(closeHour))) {
                    return openString + ' ' + closeTime;
                }
                // current time (hours) == open time (hours) || close time (hours) :: Compare Minutes {4}
                if (parseInt(currentTime) == parseInt(openHour)) {
                    // current time (min) >= open time (min)
                    if (parseInt(currMinutes) >= parseInt(openMinutes)) {
                        return openString + ' ' + closeTime;
                    }
                    // current time (min) < open time (min)
                    if (parseInt(currMinutes) < parseInt(openMinutes)) {
                        return closeString + ' ' + openTime;
                    }
                }
                if (parseInt(currentTime) == parseInt(closeHour)) {
                    // current time (min) >= open time (min)
                    if (parseInt(currMinutes) < parseInt(closeMinutes)) {
                        return openString + ' ' + closeTime;
                    }
                    // current time (min) < open time (min)
                    if (parseInt(currMinutes) >= parseInt(closeMinutes)) {
                        let day = new Date().getDay();
                        let dayHours = this.getDayHours(day + 1);
                        var res = (dayHours.includes("-")) ? dayHours.split("-") : [];
                        return (res.length > 0) ? closeString + ' ' + res[0] : closeString;
                    }
                }

            } else {
                return time;
            }
        } else {
            return '';
        }
    }

}